//http://phidels.com
//contribution collective via le forum, de JohnFullspeed, JROD,
//outch, tourlourou, rbag, Frederic, Isterix, DooMeer et Jean-Jacques. 

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    LabelResult: TLabel;
    ButtonIntToBin1: TButton;
    Label3: TLabel;
    Panel2: TPanel;
    ButtonTestIntToBin: TButton;
    Label4: TLabel;
    LabelTempsPasse: TLabel;
    Label5: TLabel;
    ButtonConversionBin: TButton;
    Button1: TButton;
    procedure ButtonIntToBin1Click(Sender: TObject);
    procedure ButtonTestIntToBinClick(Sender: TObject);
    procedure ButtonConversionBinClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure IntToBin(Value: LongInt; Buffer: PChar); 
// les paramtres sont stocks comme (par convention d'appel) : 
// Value dans eax 
// Buffer dans edx 
asm 
  push edi          // sauvegarde de edi (pointeur de destination
  mov edi, edx      // charge l'adresse de Buffer dans edi 
  mov edx, eax      // charge Value dans edx 
  mov ecx, 8        // initialise ecx  8 (nombre de tours dans la boucle) 
  xor eax, eax      // eax = 0 
  @Boucle: 
    bt edx, 28      // test du bit 28 de edx, rsultat dans la retenue 
    setc al        // si retenue = 1 ==> al = '1' sinon al = '0' 
    bt edx, 29 
    setc ah 
    bswap eax      // changes les octets 3210 de eax en 0123 
    bt edx, 30 
    setc ah 
    bt edx, 31 
    setc al 
    add eax, '0000' 
    stosd          // criture de eax dans l'emplacement point par edi et
                   //incrmentation de edi par la taille de eax (4 octets) 
    shl edx, 4      // on passe aux 4 bits suivants 
    xor eax, eax    // remise de eax  0 
    dec ecx        // dcrmentation de ecx 
  jnz @Boucle      // on reboucle si ecx est non nul 
  mov byte ptr [edi], 0  // 0 terminal de la chaine 
  pop edi                // restoration de edi  sa valeur initiale                // restoration de edi  sa valeur initiale 
end; 


function ConversionBin(nombre: longint): String;
var
  C: PChar; 
begin 
  SetLength(Result, 32); 
  FillMemory(@Result[1], 32, 48); 
  C := @Result[32]; 
  Repeat 
    C^ := chr(48 + Nombre and 1); 
    Dec(C); 
    Nombre := Nombre Shr 1; 
  Until Nombre = 0; 
end;
 

procedure TForm1.ButtonIntToBin1Click(Sender: TObject);
var x: Array[0..63] of Char;
    i,t0,t1: integer;
begin
  t0 := GetTickCount;
  for i:= 0 to 1000000 do IntToBin(i,@x);
  t1:=GetTickCount;
  LabelTempsPasse.caption:=IntToStr(t1-t0) + 'millisecondes';
end;

procedure TForm1.ButtonTestIntToBinClick(Sender: TObject);
var C:array[0..255]of char;
begin
  IntToBin(SpinEdit1.Value,c);
  LabelResult.caption:=string(c);
end;

procedure TForm1.ButtonConversionBinClick(Sender: TObject);

begin
 LabelResult.caption:= ConversionBin(SpinEdit1.Value);
end;

procedure TForm1.Button1Click(Sender: TObject);
var x: string;
    i,t0,t1: integer;
begin
  t0 := GetTickCount;
  for i:= 0 to 1000000 do x:=ConversionBin(i);
  t1:=GetTickCount;
  LabelTempsPasse.caption:=IntToStr(t1-t0) + 'millisecondes';
end;

end.
